## openlayer 2.1

=== CMakeLists.txt ===
# -------------------------------------------------------
# OpenLayer cmake build script. Creates makefiles for unix 
# based systems and/or
# project files for a given environment like MSVC.
#
# TODO:
#	* Create CYGWIN TARGET
#	* Fix MSVC
#	* Seperate into modules?
#
# Written by: juvinious
# -------------------------------------------------------

# -------------------------------------------------------
# Ensure that we are doing an out of source build
# Prevents any mishaps
# -------------------------------------------------------
if(EXISTS ${CMAKE_SOURCE_DIR}/CMakeCache.txt)
	file(REMOVE ${CMAKE_SOURCE_DIR}/CMakeCache.txt)
	file(REMOVE_RECURSE ${CMAKE_SOURCE_DIR}/CMakeFiles)
endif(EXISTS ${CMAKE_SOURCE_DIR}/CMakeCache.txt)
if(EXISTS ${CMAKE_BINARY_DIR}/Makefile)
	file(REMOVE ${CMAKE_BINARY_DIR}/Makefile)
endif(EXISTS ${CMAKE_BINARY_DIR}/Makefile)	
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
	if(UNIX AND NOT CYGWIN)
		message(FATAL_ERROR "Oops. Don't do an in-source build. Create an extra directory change into it and run cmake pointing to the base directory. IE: \nmkdir mybuild && cd mybuild && cmake ../ && make\nYou may need to remove CMakeCache.txt and the CMakeFiles directory in ${CMAKE_SOURCE_DIR} if you can't get rid of this error.")
	else(UNIX AND NOT CYGWIN)
		message(FATAL_ERROR "Oops. Don't do an in-source build. Create an extra directory change into it and run cmake pointing to the base directory. IE: \nmkdir mybuild; cd mybuild; cmakesetup ../\nYou may need to remove CMakeCache.txt and the CMakeFiles directory in  ${CMAKE_SOURCE_DIR} if you can't get rid of this error.")
	endif(UNIX AND NOT CYGWIN)
endif(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})


# -------------------------------------------------------
# Set working directories
# -------------------------------------------------------
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)


# -------------------------------------------------------
# Directory in which extra macros can be found
# -------------------------------------------------------
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/build)

# -------------------------------------------------------
# Add in uninstall target 
# -------------------------------------------------------
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/build/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# -------------------------------------------------------
# project name
# -------------------------------------------------------
project (OpenLayer)

# -------------------------------------------------------
# Including needed macros
# -------------------------------------------------------
include(CMakeMacros)
find_package(ZLIB)
find_package(FREETYPE)
find_package(PNG)
find_package(ALLEGRO REQUIRED)
find_package(OpenGL REQUIRED)
find_package(ALLEGROGL REQUIRED)

MARK_AS_ADVANCED(
  CLEAR
  ZLIB_LIBRARY
  ZLIB_INCLUDE_DIR
  PNG_LIBRARY
  PNG_INCLUDE_DIR
  OPENGL_glu_LIBRARY
  OPENGL_gl_LIBRARY
  OPENGL_INCLUDE_DIR
  )

# -------------------------------------------------------
# User setable options
# -------------------------------------------------------
option(CREATE_STATIC_LIB "Make the library static?" on)
dependent_option(DISABLE_TTF "Disable TTF Support" off "FREETYPE_FOUND" on)
if(NOT DISABLE_TTF)
	set(TTF_OK 1)
endif(NOT DISABLE_TTF)
dependent_option(ENABLE_INTERNAL_FONT "Use internal font renderer" on "TTF_OK" on)
# dependent_option(DISABLE_PNG "Disable PNG support" on "PNG_FOUND" on)
option(DISABLE_PNG "Disable PNG support" off)
option(DISABLE_OLD_API "Disable backwards compatibility with 2.0 and below" off)
option(DISABLE_STATE_CHANGES "Disable state changes" off)

if(NOT MSVC)
	set(CXXFLAGS "-O2 -Wall -fexpensive-optimizations")
else(NOT MSVC)
	set(CXXFLAGS "-O2")
endif(NOT MSVC)

add_definitions(${CXXFLAGS})

# -------------------------------------------------------
# Check whether to create a shared or static library
# -------------------------------------------------------
if(CREATE_STATIC_LIB)
	set(CREATE_STATIC_LIB STATIC)
else(CREATE_STATIC_LIB)
	set(CREATE_STATIC_LIB SHARED)
	set(OL_SHARED 1)
	set(OL_LIB_BUILD 1)
	if(MSVC)
		add_definitions(/DOL_SHARED)
		add_definitions(/DOL_LIB_BUILD)
	else(MSVC)
		add_definitions(-DOL_SHARED)
		add_definitions(-DOL_LIB_BUILD)
	endif(MSVC)
endif(CREATE_STATIC_LIB)

# -------------------------------------------------------
# Paths and system setup
# -------------------------------------------------------

# -------------------------------------------------------
# UNIX BASED SYSTEMS
# -------------------------------------------------------
if(UNIX AND NOT CYGWIN)
	# -------------------------------------------------------
	# Take those user options and set the necessary compile time preprocessors
	# -------------------------------------------------------
	if(NOT DISABLE_TTF)
		if(ENABLE_INTERNAL_FONT)
			add_definitions(-DUSE_NEW_TTF)
			set(USE_NEW_TTF 1)
		endif(ENABLE_INTERNAL_FONT)
	else(NOT DISABLE_TTF)
		add_definitions(-DOL_NO_TTF)
		set(OL_NO_TTF 1)
	endif(NOT DISABLE_TTF)
	if(DISABLE_PNG)
		add_definitions(-DOL_NO_PNG)
		set(OL_NO_PNG 1)
	endif(DISABLE_PNG)
	if(DISABLE_OLD_API)
		add_definitions(-DOL_NO_OLD_API)
		set(OL_NO_OLD_API 1)
	endif(DISABLE_OLD_API)
	if(DISABLE_STATE_CHANGES)
		add_definitions(-DOL_NO_STATE_CHANGE)
		set(OL_NO_STATE_CHANGE 1)
	endif(DISABLE_STATE_CHANGES)
	
	if(NOT ENABLE_INTERNAL_FONT)
		add_subdirectory(utils/glyphkeeper)
		set(GLYPHKEEPER_LIB glyph-agl)
	endif(NOT ENABLE_INTERNAL_FONT)
endif(UNIX AND NOT CYGWIN)

# -------------------------------------------------------
# MINGW
# -------------------------------------------------------

if(MINGW)
	# -------------------------------------------------------
	# Take those user options and set the necessary compile time preprocessors
	# -------------------------------------------------------
	if(NOT DISABLE_TTF)
		if(ENABLE_INTERNAL_FONT)
			add_definitions(-DUSE_NEW_TTF)
			set(USE_NEW_TTF 1)
		endif(ENABLE_INTERNAL_FONT)
	else(NOT DISABLE_TTF)
		add_definitions(-DOL_NO_TTF)
		set(OL_NO_TTF 1)
	endif(NOT DISABLE_TTF)
	if(DISABLE_PNG)
		add_definitions(-DOL_NO_PNG)
		set(OL_NO_PNG 1)
	endif(DISABLE_PNG)
	if(DISABLE_OLD_API)
		add_definitions(-DOL_NO_OLD_API)
		set(OL_NO_OLD_API 1)
	endif(DISABLE_OLD_API)
	if(DISABLE_STATE_CHANGES)
		add_definitions(-DOL_NO_STATE_CHANGE)
		set(OL_NO_STATE_CHANGE 1)
	endif(DISABLE_STATE_CHANGES)
	
	if(NOT ENABLE_INTERNAL_FONT)
		add_subdirectory(utils/glyphkeeper)
		set(GLYPHKEEPER_LIB glyph-agl)
	endif(NOT ENABLE_INTERNAL_FONT)
	
	set(WIN_LIBS -luser32 -lgdi32) 
endif(MINGW)

# -------------------------------------------------------
# MSVC
# -------------------------------------------------------

if(MSVC)
	# -------------------------------------------------------
	# Take those user options and set the necessary compile time preprocessors
	# -------------------------------------------------------
	SET(CMAKE_CXX_FLAGS "/nologo /W3 /Gy")
    	SET(CMAKE_CXX_FLAGS_DEBUG "/MTd /Z7 /Od")
	SET(CMAKE_CXX_FLAGS_RELEASE "/MT /O2")
	SET(CMAKE_CXX_FLAGS_MINSIZEREL "/MT /O2")
	SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "/MTd /Z7 /Od")
	set(CMAKE_CONFIGURATION_TYPES Release)
	add_definitions("/link SUBSYSTEM:WINDOWS")
	
	if(NOT DISABLE_TTF)
		if(ENABLE_INTERNAL_FONT)
			add_definitions(/DUSE_NEW_TTF)
			set(USE_NEW_TTF 1)
		endif(ENABLE_INTERNAL_FONT)
	else(NOT DISABLE_TTF)
		add_definitions(/DOL_NO_TTF)
		set(OL_NO_TTF 1)
	endif(NOT DISABLE_TTF)
	if(DISABLE_PNG)
		add_definitions(/DOL_NO_PNG)
		set(OL_NO_PNG 1)
	endif(DISABLE_PNG)
	if(DISABLE_OLD_API)
		add_definitions(/DOL_NO_OLD_API)
		set(OL_NO_OLD_API 1)
	endif(DISABLE_OLD_API)
	if(DISABLE_STATE_CHANGES)
		add_definitions(/DOL_NO_STATE_CHANGE)
		set(OL_NO_STATE_CHANGE 1)
	endif(DISABLE_STATE_CHANGES)
	
	if(NOT ENABLE_INTERNAL_FONT)
		add_subdirectory(utils/glyphkeeper)
		set(GLYPHKEEPER_LIB glyph-agl)
	endif(NOT ENABLE_INTERNAL_FONT)
	
	set(WIN_LIBS /user32 /gdi32) 
endif(MSVC)

# -------------------------------------------------------
# Added stuff for osx
# -------------------------------------------------------
if(APPLE)
	set(WIN_LIBS "-framework Carbon")
endif(APPLE)

# -------------------------------------------------------
# Setup some vars that might cause dep issues
# -------------------------------------------------------
if(DISABLE_PNG)
	set(PNG_LIB "")
else(DISABLE_PNG)
	set(PNG_LIB ${PNG_LIBRARY})
endif(DISABLE_PNG)
if(DISABLE_TTF)
	set(FREETYPE_LIB "")
	set(FREETYPE_INCLUDE "")
	set(ZLIB_LIB "")
else(DISABLE_TTF)
	set(FREETYPE_LIB ${FREETYPE_LIBRARY})
	set(FREETYPE_INCLUDE ${FREETYPE_INCLUDE_DIR})
	set(ZLIB_LIB ${ZLIB_LIBRARY})
endif(DISABLE_TTF)	

# -------------------------------------------------------
# Create the necessary header file for the library
# -------------------------------------------------------
configure_file(build/OpenLayer.hpp.in ${CMAKE_BINARY_DIR}/include/OpenLayer.hpp)

# -------------------------------------------------------
# openlayer-config for *nix based systems
# -------------------------------------------------------
if(UNIX AND NOT CYGWIN)
	if(NOT DISABLE_TTF)
		if(NOT ENABLE_INTERNAL_FONT)
			set(R_GK -lglyph-agl)
		endif(NOT ENABLE_INTERNAL_FONT)
		set(R_FT -lfreetype)
	endif(NOT DISABLE_TTF)
	if(NOT DISABLE_PNG)
		set(R_PNG -lpng)
	endif(NOT DISABLE_PNG)
	set(REQUIRED_LIBS "-lagl ${R_PNG} ${R_GK} ${R_FT} -lz `allegro-config --libs` -lGL -lGLU")
	configure_file(build/openlayer-config.in ${CMAKE_BINARY_DIR}/bin/openlayer-config ESCAPE_QUOTES)
endif(UNIX AND NOT CYGWIN)

# -------------------------------------------------------
# Source directory containing all the necessary .cpp files
# -------------------------------------------------------
aux_source_directory(src SOURCES)

# -------------------------------------------------------
# Include directory
# -------------------------------------------------------
include_directories(include ${CMAKE_BINARY_DIR}/include include/OpenLayer ${FREETYPE_INCLUDE})

# -------------------------------------------------------
# OpenLayer Library
# -------------------------------------------------------
add_library (openlayer ${CREATE_STATIC_LIB} ${SOURCES})

# -------------------------------------------------------
# Create the library
# -------------------------------------------------------
target_link_libraries(openlayer ${ALLEGROGL_LIBRARY} ${PNG_LIB} ${GLYPHKEEPER_LIB} ${FREETYPE_LIB} ${ZLIB_LIB} ${ALLEGRO_LIBRARY} ${OPENGL_LIBRARIES} ${WIN_LIBS})

# -------------------------------------------------------
# Demos
# -------------------------------------------------------
add_subdirectory(${CMAKE_SOURCE_DIR}/demos)

# -------------------------------------------------------
# Installation
# -------------------------------------------------------
if(NOT MSVC)
	if(NOT ${CMAKE_INSTALL_PREFIX} AND ${CMAKE_INSTALL_PREFIX} STREQUAL "")
		message(FATAL_ERROR "You need to set the base location where to install OpenLayer (ie /usr/local)")
	endif(NOT ${CMAKE_INSTALL_PREFIX} AND ${CMAKE_INSTALL_PREFIX} STREQUAL "")
	install(FILES ${CMAKE_BINARY_DIR}/include/OpenLayer.hpp DESTINATION ${CMAKE_INSTALL_PREFIX}/include)
	install(DIRECTORY include/OpenLayer DESTINATION ${CMAKE_INSTALL_PREFIX}/include PATTERN ".svn" EXCLUDE PATTERN "*~" EXCLUDE)
	install(TARGETS openlayer DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
	if(UNIX AND NOT CYGWIN)
		install(PROGRAMS ${CMAKE_BINARY_DIR}/bin/openlayer-config DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
	endif(UNIX AND NOT CYGWIN)
endif(NOT MSVC)

=== demos/CMakeLists.txt ===
# -------------------------------------------------------
# OpenLayer cmake build script to create demos called from 
# main build
# Written by: juvinious
# -------------------------------------------------------

if(NOT ${CREATE_STATIC_LIB})
	set(OL_LIB_BUILD 0)
	if(MSVC)
		remove_definitions(/DOL_LIB_BUILD)
	else(MSVC)
		remove_definitions(-DOL_LIB_BUILD)
	endif(MSVC)
endif(NOT ${CREATE_STATIC_LIB})

# -------------------------------------------------------
# Create the examples
# -------------------------------------------------------
add_executable(collisiondemo ${CMAKE_SOURCE_DIR}/demos/collisiondemo/main.cpp)
target_link_libraries(collisiondemo openlayer ${ALLEGROGL_LIBRARY} ${PNG_LIB} ${GLYPHKEEPER_LIB} ${FREETYPE_LIB} ${ZLIB_LIB} ${ALLEGRO_LIBRARY} ${OPENGL_LIBRARIES} ${WIN_LIBS})
add_dependencies(collisiondemo openlayer)

add_executable(gamedemo ${CMAKE_SOURCE_DIR}/demos/gamedemo/Demo.cpp)
target_link_libraries(gamedemo openlayer ${ALLEGROGL_LIBRARY} ${PNG_LIB} ${GLYPHKEEPER_LIB} ${FREETYPE_LIB} ${ZLIB_LIB} ${ALLEGRO_LIBRARY} ${OPENGL_LIBRARIES} ${WIN_LIBS})
add_dependencies(gamedemo openlayer)
configure_file(${CMAKE_SOURCE_DIR}/demos/gamedemo/Fonts/Neuropol.ttf ${CMAKE_BINARY_DIR}/bin/Fonts/Neuropol.ttf COPYONLY)
configure_file(${CMAKE_SOURCE_DIR}/demos/gamedemo/Gfx/Background.png ${CMAKE_BINARY_DIR}/bin/Gfx/Background.png COPYONLY)
configure_file(${CMAKE_SOURCE_DIR}/demos/gamedemo/Gfx/Ball.png ${CMAKE_BINARY_DIR}/bin/Gfx/Ball.png COPYONLY)
configure_file(${CMAKE_SOURCE_DIR}/demos/gamedemo/Gfx/Blocks/Block01.png ${CMAKE_BINARY_DIR}/bin/Gfx/Blocks/Block01.png COPYONLY)
configure_file(${CMAKE_SOURCE_DIR}/demos/gamedemo/Gfx/Blocks/Block02.png ${CMAKE_BINARY_DIR}/bin/Gfx/Blocks/Block02.png COPYONLY)
configure_file(${CMAKE_SOURCE_DIR}/demos/gamedemo/Gfx/Blocks/Block03.png ${CMAKE_BINARY_DIR}/bin/Gfx/Blocks/Block03.png COPYONLY)
configure_file(${CMAKE_SOURCE_DIR}/demos/gamedemo/Gfx/Blocks/Block04.png ${CMAKE_BINARY_DIR}/bin/Gfx/Blocks/Block04.png COPYONLY)
configure_file(${CMAKE_SOURCE_DIR}/demos/gamedemo/Gfx/Paddle.png ${CMAKE_BINARY_DIR}/bin/Gfx/Paddle.png COPYONLY)

add_executable(gameloop ${CMAKE_SOURCE_DIR}/demos/gameloop/Main.cpp)
target_link_libraries(gameloop openlayer ${ALLEGROGL_LIBRARY} ${PNG_LIB} ${GLYPHKEEPER_LIB} ${FREETYPE_LIB} ${ZLIB_LIB} ${ALLEGRO_LIBRARY} ${OPENGL_LIBRARIES} ${WIN_LIBS})
add_dependencies(gameloop openlayer)
configure_file(${CMAKE_SOURCE_DIR}/demos/gameloop/Gfx/Bitmap.png ${CMAKE_BINARY_DIR}/bin/Gfx/Bitmap.png COPYONLY)

add_executable(linestripdemo ${CMAKE_SOURCE_DIR}/demos/linestripdemo/Main.cpp)
target_link_libraries(linestripdemo openlayer ${ALLEGROGL_LIBRARY} ${PNG_LIB} ${GLYPHKEEPER_LIB} ${FREETYPE_LIB} ${ZLIB_LIB} ${ALLEGRO_LIBRARY} ${OPENGL_LIBRARIES} ${WIN_LIBS})
add_dependencies(linestripdemo openlayer)

add_executable(renderbitmap ${CMAKE_SOURCE_DIR}/demos/renderbitmap/Main.cpp)
target_link_libraries(renderbitmap openlayer ${ALLEGROGL_LIBRARY} ${PNG_LIB} ${GLYPHKEEPER_LIB} ${FREETYPE_LIB} ${ZLIB_LIB} ${ALLEGRO_LIBRARY} ${OPENGL_LIBRARIES} ${WIN_LIBS})
add_dependencies(renderbitmap openlayer)

add_executable(shapedemo ${CMAKE_SOURCE_DIR}/demos/shapedemo/Main.cpp)
target_link_libraries(shapedemo openlayer ${ALLEGROGL_LIBRARY} ${PNG_LIB} ${GLYPHKEEPER_LIB} ${FREETYPE_LIB} ${ZLIB_LIB} ${ALLEGRO_LIBRARY} ${OPENGL_LIBRARIES} ${WIN_LIBS})
add_dependencies(shapedemo openlayer)
configure_file(${CMAKE_SOURCE_DIR}/demos/shapedemo/Gfx/PointerAlpha.bmp ${CMAKE_BINARY_DIR}/bin/Gfx/PointerAlpha.bmp COPYONLY)
configure_file(${CMAKE_SOURCE_DIR}/demos/shapedemo/Gfx/PointerAlpha.png ${CMAKE_BINARY_DIR}/bin/Gfx/PointerAlpha.png COPYONLY)

add_executable(textdemo ${CMAKE_SOURCE_DIR}/demos/textdemo/Main.cpp)
target_link_libraries(textdemo openlayer ${ALLEGROGL_LIBRARY} ${PNG_LIB} ${GLYPHKEEPER_LIB} ${FREETYPE_LIB} ${ZLIB_LIB} ${ALLEGRO_LIBRARY} ${OPENGL_LIBRARIES} ${WIN_LIBS})
add_dependencies(textdemo openlayer)

=== demos/gamedemo/Makefile ===
#demos/gamedemo/Makefile


	
EXE_SOURCES=Demo.cpp
EXE=gamedemo

ifeq "$(ENVIRONMENT)" "WINDOWS"
EXE :=$(EXE).exe
endif

ifeq "$(ENVIRONMENT)" "MSYS"
EXE :=$(EXE).exe
endif


all: $(EXE)

.PHONY: all clean

clean:
	@echo "Making clean..."
	$(RM) *.o
	$(RM) $(EXE)
	@echo "Demo is cleaned"

$(EXE): $(EXE_SOURCES)
	$(CC) $(CFLAGS) $(LDFLAGS) $(EXE_SOURCES) ../../lib/$(LIB) $(LIBFLAGS) -o $@

=== demos/gameloop/Makefile ===
#demos/gameloop/Makefile


	
EXE_SOURCES=Main.cpp
EXE=gameloop

ifeq "$(ENVIRONMENT)" "WINDOWS"
EXE :=$(EXE).exe
endif

ifeq "$(ENVIRONMENT)" "MSYS"
EXE :=$(EXE).exe
endif


all: $(EXE)

.PHONY: all clean

clean:
	@echo "Making clean..."
	$(RM) *.o
	$(RM) $(EXE)
	@echo "Demo is cleaned"

$(EXE): $(EXE_SOURCES)
	$(CC) $(CFLAGS) $(LDFLAGS) $(EXE_SOURCES) ../../lib/$(LIB) $(LIBFLAGS) -o $@

=== demos/linestripdemo/Makefile ===
#demos/linestripdemo/Makefile


	
EXE_SOURCES=Main.cpp
EXE=linestripdemo

ifeq "$(ENVIRONMENT)" "WINDOWS"
EXE :=$(EXE).exe
endif

ifeq "$(ENVIRONMENT)" "MSYS"
EXE :=$(EXE).exe
endif


all: $(EXE)

.PHONY: all clean

clean:
	@echo "Making clean..."
	$(RM) *.o
	$(RM) $(EXE)
	@echo "Demo is cleaned"

$(EXE): $(EXE_SOURCES)
	$(CC) $(CFLAGS) $(LDFLAGS) $(EXE_SOURCES) ../../lib/$(LIB) $(LIBFLAGS) -o $@

=== demos/renderbitmap/Makefile ===
#demos/renderbitmap/Makefile


	
EXE_SOURCES=Main.cpp
EXE=renderbitmap

ifeq "$(ENVIRONMENT)" "WINDOWS"
EXE :=$(EXE).exe
endif

ifeq "$(ENVIRONMENT)" "MSYS"
EXE :=$(EXE).exe
endif


all: $(EXE)

.PHONY: all clean

clean:
	@echo "Making clean..."
	$(RM) *.o
	$(RM) $(EXE)
	@echo "Demo is cleaned"

$(EXE): $(EXE_SOURCES)
	$(CC) $(CFLAGS) $(LDFLAGS) $(EXE_SOURCES) ../../lib/$(LIB) $(LIBFLAGS) -o $@

=== demos/textdemo/Makefile ===
#demos/textdemo/Makefile


	
EXE_SOURCES=Main.cpp
EXE=textdemo

ifeq "$(ENVIRONMENT)" "WINDOWS"
EXE :=$(EXE).exe
endif

ifeq "$(ENVIRONMENT)" "MSYS"
EXE :=$(EXE).exe
endif


all: $(EXE)

.PHONY: all clean

clean:
	@echo "Making clean..."
	$(RM) *.o
	$(RM) $(EXE)
	@echo "Demo is cleaned"

$(EXE): $(EXE_SOURCES)
	$(CC) $(CFLAGS) $(LDFLAGS) $(EXE_SOURCES) ../../lib/$(LIB) $(LIBFLAGS) -o $@

=== utils/glyphkeeper/CMakeLists.txt ===
# -------------------------------------------------------
# GlyphKeeper cmake build script if not using internal
# renderer
# Written by: juvinious
# -------------------------------------------------------

# -------------------------------------------------------
# project name
# -------------------------------------------------------
project (GlyphKeeper)

# -------------------------------------------------------
# Including needed macros
# -------------------------------------------------------
find_package(FREETYPE REQUIRED)
find_package(ALLEGROGL REQUIRED)

if(NOT MSVC)
	add_definitions(-DGK_NO_LEGACY -DGLYPH_TARGET=GLYPH_TARGET_ALLEGGL)
else(NOT MSVC)
	add_definitions(/DGK_NO_LEGACY /DGLYPH_TARGET=GLYPH_TARGET_ALLEGGL)
endif(NOT MSVC)


# -------------------------------------------------------
# Source directory containing all the necessary .cpp files
# -------------------------------------------------------
set(GK_SOURCES src/glyph.c src/glyph_global_vars.c src/glyph_rend.c src/glyph_to_allegro_mono.c src/glyph_dimensions.c src/glyph_index.c src/glyph_to_allegro_aa.c src/glyph_to_opengl.c src/glyph_face.c src/glyph_main.c src/glyph_to_allegro.c src/glyph_utils.c src/glyph_memory.c src/glyph_workout.c)

# -------------------------------------------------------
# Include directory
# -------------------------------------------------------
include_directories(include src ${FREETYPE_INCLUDE_DIR})

# -------------------------------------------------------
# OpenLayer Library
# -------------------------------------------------------
add_library (glyph-agl ${CREATE_STATIC_LIBRARY} ${GK_SOURCES})

# -------------------------------------------------------
# Create the library
# -------------------------------------------------------
target_link_libraries(glyph-agl)
configure_file(include/glyph.h ${CMAKE_BINARY_DIR}/include/glyph.h COPYONLY)

# -------------------------------------------------------
# Installation
# -------------------------------------------------------
if(NOT MSVC)
	install(FILES ${CMAKE_BINARY_DIR}/include/glyph.h DESTINATION ${CMAKE_INSTALL_PREFIX}/include)
	install(TARGETS glyph-agl DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
endif(NOT MSVC)

=== debian/changelog ===
openlayer (2.1-2.1build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:22:04 +0100

openlayer (2.1-2.1build1) yakkety; urgency=medium

  * No-change rebuild for libpng soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Apr 2016 00:17:55 +0000

openlayer (2.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "FTBFS with libpng16" -- new library requires some includes
    and has API change. (Closes: #809870)

 -- Tobias Frost <tobi@debian.org>  Sun, 24 Jan 2016 13:26:24 +0100

openlayer (2.1-2) unstable; urgency=medium

  * upgraded the dependency on libpng-dev. Closes: #809870
  * removed the obsoleted dependency on hardening-wrapper and activated
    dpkg-buildflags features

 -- Georges Khaznadar <georgesk@debian.org>  Sat, 09 Jan 2016 17:33:38 +0100

openlayer (2.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename library packages for g++5 ABI transition (closes: 791228).

 -- Julien Cristau <jcristau@debian.org>  Sun, 16 Aug 2015 17:51:28 +0200

openlayer (2.1-1) unstable; urgency=low

  * Initial release (Closes: #735016)
  * modified files related to src/Collisions.cpp, in order to prevent
    a compilation error for recent versions of g++ (mainly made more explicit
    a typedef based on templates).
  * modified CMakefile.txt to follow the Debian Policy for shared libraries
  * fixed an error to make possible the hardening options
  * improved the file d/copyright, thanks to Thorsten Alteholz 
    <ftpmaster@ftp-master.debian.org>

 -- Georges Khaznadar <georgesk@debian.org>  Mon, 06 Jan 2014 14:33:43 +0100

=== debian/control ===
Source: openlayer
Section: devel
Priority: extra
Maintainer: Georges Khaznadar <georgesk@debian.org>
Build-Depends: debhelper (>= 8.0.0), cmake,
 zlib1g-dev, libpng-dev, liballegro4-dev, libxext-dev, libx11-dev, 
 liballeggl4-dev, libgl1-mesa-dev, libglu1-mesa-dev,
 libfreetype6-dev
Standards-Version: 3.9.5
Homepage: http://openlayer.berlios.de/

Package: libopenlayer2v5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libopenlayer2
Replaces: libopenlayer2
Description: hardware accelerated 2D Graphics library
 OpenLayer is a hardware accelerated 2D Graphics library. It specifies
 a new api to be used alongside of Allegro and takes control of how
 the contents of the screen are rendered and uses OpenGL functions
 through AllegroGL to allow hardware acceleration.

Package: libopenlayer-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenlayer2v5 (= ${binary:Version})
Description: hardware accelerated 2D Graphics library : development files
 OpenLayer is a hardware accelerated 2D Graphics library. It specifies
 a new api to be used alongside of Allegro and takes control of how
 the contents of the screen are rendered and uses OpenGL functions
 through AllegroGL to allow hardware acceleration.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

DESTDIR = $(CURDIR)/debian/cdcover

%:
	dh $@
